PACKAGE do 
IS
	/* Sets the flag which controls output from do.pl */
	PROCEDURE switch (show_in IN VARCHAR2 := NULL);

	/* The overloaded versions of the pl procedure */

	/* Display a date. Can specify a format mask or use the default. */
	PROCEDURE pl 
		(date_in IN DATE, 
		 mask_in IN VARCHAR2 := 'Month DD, YYYY - HH:MI:SS PM',
		 show_in IN VARCHAR2 := NULL); 

	/* Display a number. */
	PROCEDURE pl (number_in IN NUMBER, show_in IN VARCHAR2 := NULL);

	/* Display a string. */
	PROCEDURE pl (char_in IN VARCHAR2, show_in IN VARCHAR2 := NULL);

	/* Display a string followed by a number. */
	PROCEDURE pl 
		(char_in IN VARCHAR2, 
		 number_in IN NUMBER, 
		 show_in IN VARCHAR2 := NULL);

	/* Display a string followed by a date. */
	PROCEDURE pl 
		(char_in IN VARCHAR2, 
		 date_in IN DATE,
		 mask_in IN VARCHAR2 := 'Month DD, YYYY - HH:MI:SS PM',
		 show_in IN VARCHAR2 := NULL);

	/* Display a Boolean value. */
	PROCEDURE pl (boolean_in IN BOOLEAN, show_in IN VARCHAR2 := NULL);

	/* Display a string and then a Boolean value. */	
	PROCEDURE pl 
		(char_in IN VARCHAR2, 
		 boolean_in IN BOOLEAN, 
		 show_in IN VARCHAR2 := NULL);

END do;
