PACKAGE array
IS
	/* Returns the number of rows in the array */
	FUNCTION row_count RETURN INTEGER;

	/* Returns the number of columns in the array */
	FUNCTION column_count RETURN INTEGER;

	/* Create an array */
	PROCEDURE make 
		(num_rows_in IN INTEGER := 10, 
		 num_columns_in IN INTEGER := 1,
		 initial_value_in IN NUMBER := NULL,
		 conflict_action_in IN VARCHAR2 := 'OVERWRITE'); 

	/* Return the value in a cell */
	FUNCTION cell (row_in IN INTEGER, col_in IN INTEGER)
		RETURN NUMBER;

	/* Change the value in a cell */
	PROCEDURE change 
		(row_in IN INTEGER, col_in IN INTEGER, value_in IN NUMBER);

	/* Erase the array */
	PROCEDURE erase;

	/* Display the array */
	PROCEDURE display 
		(start_row_in IN INTEGER := 1,
		 end_row_in IN INTEGER := row_count,
		 start_col_in IN INTEGER := 1,
		 end_col_in IN INTEGER := column_count,
		 display_style_in IN VARCHAR2 := 'ARRAY');

END array;
