PROCEDURE custom_debug_action (action_in IN VARCHAR2)
IS
	sql_statement VARCHAR2(1000);
	cursor_id INTEGER;
BEGIN
	IF action_in = 'SQL'
	THEN
		/*
		|| Unpack the next item containing the SQL statement, and 
		|| then use the DBMS_SQL package to execute the statement.
		*/
		DBMS_PIPE.UNPACK_MESSAGE (sql_statement);
		cursor_id := DBMS_SQL.OPEN_CURSOR;
		DBMS_SQL.PARSE (cursor_id, sql_statement, DBMS_SQL.V7);
		DBMS_SQL.CLOSE_CURSOR (cursor_id);

	ELSIF action_in = 'RESET'
	THEN
		-- Call application-specific module to reset values of variables.
		reset_variables;

	ELSIF action_in = 'NEWUSER'
	THEN
		-- Unpack next item to change value of current user ID.
		DBMS_PIPE.UNPACK_MESSAGE (config_pkg.user_id);

	END IF;
END;
